namespace GossamerVR.MorphFilterPlus
{
    using UnityEngine;
    using System;

    /// <summary>
    /// A simple component that sends an event on enable / disable.
    /// Used by the morph filter to recognize when the ui panel is getting enabled.
    /// </summary>
    public class StateListener : MonoBehaviour
    {
        public Atom Owner;
        public event EventHandler EnabledEvent;
        public event EventHandler DisabledEvent;

        private void OnEnable()
        {
            this.EnabledEvent?.Invoke(this, EventArgs.Empty);
        }

        private void OnDisable()
        {
            this.DisabledEvent?.Invoke(this, EventArgs.Empty);
        }
    }
}